SDA	BIT		P1.0		;定义I2C信号引脚
	SCL	BIT		P1.1
	WSLA_8563	EQU	0A2H	;PCF8563T口地址
	RSLA_8563	EQU	0A3H	
	WSLA_7290	EQU	70H		;ZLG7290B口地址
	RSLA_7290	EQU	71H
	ORG	0000H
	LJMP	0100H
	ORG	0003H
	LJMP	INT_7290
	ORG	0013H
	LJMP	INT_RCT
	ORG	0100H

START:
	MOV	SP,#60H
	CLR	P1.7			;ZLG7290B复位
	LCALL	DELAY
	SETB	P1.7
;-----设定PCF8563T的时间和命令参数（参数和命令缓冲区10H-1DH）------
	MOV	10H,#00H		;启动控制字
	MOV	11H,#1FH		;设置报警及定时器中断
	MOV	12H,#50H		;秒单元
	MOV	13H,#59H		;分单元
	MOV	14H,#08H		;小时单元
	MOV	15H,#10H		;日期单元
	MOV	16H,#05H		;星期单元
	MOV	17H,#05H		;月单元
	MOV	18H,#24H		;年单元
	MOV	19H,#00H		;设定时报警
	MOV	1AH,#00H		;设定小时报警
	MOV	1BH,#00H		;设定日报警
	MOV	1CH,#00H		;设定星期报警
	MOV	1DH,#83H		;设定CLKOUT的频率（1s）
;------------------------------------------------------------------
	LCALL	WR8563
	SETB	EA
	SETB	EX0			;开中断总开关
	SETB	EX1			;下沿触发模式
	SETB	IT0			;开中断0
	SETB	IT1			;开中断1
	SJMP	$			;等待中断

;------利用ZLG7290每秒显示一次子程序------
INT_RCT:	
	MOV	R7,#07H			;读出数据个数
	MOV	R0,#20H			;目标数据块首地址
	MOV	R2,#02H			;从器件内部地址
	MOV	R3,#WSLA_8563	
	MOV	R4,#RSLA_8563		;准备读时间参数
	LCALL	RDADD			;调读数据子程序，读出数据存于20-26H		
	LCALL	ADJUST			;调时间调整子程序
	LCALL	CHAIFEN			;拆分子程序并查表将20-26H单元参数存于28-2FH,38-3FH
	MOV	R7,#08H	
	MOV	R2,#10H
	MOV	R3,#WSLA_7290
	JNB	P1.2,YEARS		;使用P1.2控制显示内容
	MOV	R0,#38H			;显示小时，分钟和秒
	SJMP	DISP
YEARS:	
	MOV	R0,#28H			;显示年、月和日期
DISP:	
	LCALL	WRNBYT			;调ZLG7290B显示
	MOV	R1,#21H			;读取分的参数
	MOV	R0,#20H			;读取秒的参数
D1:	
	CJNE	@R1,#59H,ALARM		;判断分参数是否等于59
	CJNE	@R0,#56H,D2		;判断秒参数是否等于56
	LCALL	BUZZ			;当分参数为59秒参数为56时报警
	SJMP	STPA

D2:	
	CJNE	@R0,#57H,D3		;当分参数为59秒参数为57时报警
	LCALL	BUZZ
	SJMP	STPA
D3:	
	CJNE	@R0,#58H,D4		;当分参数为59秒参数为58时报警
	LCALL	BUZZ
	SJMP	STPA
D4:	
	CJNE	@R0,#59H,STPA		;当分参数为59秒参数为59时报警
	LCALL	BUZZ
	SJMP	STPA
ALARM:	
	CJNE	@R1,#00H,STPA		;判断分参数是否等于00
	CJNE	@R0,#00H,STPA		;判断秒参数是否等于00
	LCALL	BUZZ1			;当分参数为00秒参数为00时长报警
STPA:	
	JNB	P3.2,$
	RETI
;------拆分并查表------
CHAIFEN:	
	PUSH	PSW			;对20-26H单元参数拆分
	PUSH	ACC			;查表后送入28-2FH（年。月。日）
	PUSH	03H			;查表后送入38-3FH（时，分，秒）
	PUSH	04H
	MOV	A,20H			;取秒参数
	LCALL	CF			;拆分、查表，将字型码装于R4，R3中
	MOV	38H,R3			;送秒的个位
	MOV	39H,R4			;送秒的十位
	MOV	3AH,#02H		;送分隔符-

	MOV	A,21H			;取分参数
	LCALL	CF			;拆分、查表，将字型码装于R4，R3中
	MOV	3BH,R3			;送分的个位
	MOV	3CH,R4			;送分的十位
	MOV	3DH,#02H		;送分隔符-
	MOV	A,22H			;取小时参数
	LCALL	CF			;拆分、查表，将字型码装于R4，R3中
	MOV	3EH,R3			;送小时的个位
	MOV	3FH,R4			;送小时的十位

	MOV	A,23H			;取日期参数
	LCALL	CF
	MOV	A,R3
	ORL	A,#01H
	MOV	R3,A
	MOV	28H,R3
	MOV	29H,R4
	
	MOV	A,25H			;取月参数
	LCALL	CF
	MOV	A,R3
	ORL	A,#01H
	MOV	R3,A
	MOV	2AH,R3
	MOV	2BH,R4

	MOV	A,26H			;取年参数
	LCALL	CF
	MOV	A,R3
	ORL	A,#01H
	MOV	R3,A
	MOV	2CH,R3
	MOV	2DH,R4
	
	MOV	2EH,#0FCH		;年的高两位处理
	MOV	2FH,#0DAH
	POP		04H
	POP		03H
	POP		ACC
	POP		PSW
	RET
;--------------------------------------------------
CF:
	PUSH	02H			;将A中的数据拆分为两个独立的BCD码并查表
	PUSH	DPH		
	PUSH	DPL			;结果分别存在R4，R3中
	MOV	DPTR,#LEDSEG
	MOV	R2,A
	ANL	A,#0FH
	MOVC	A,@A+DPTR
	MOV	R3,A
	MOV	A,R2
	SWAP	A
	ANL	A,#0FH
	MOVC	A,@A+DPTR
	MOV	R4,A
	POP		DPL
	POP		DPH
	POP		02H
	RET
;--------------------------------------------------
LEDSEG:	
	DB		0FCH,60H,0DAH,0F2H,66H,0B6H,0BEH,0E4H
	DB		0FEH,0F6H,0EEH,3EH,9CH,7AH,9EH,8EH
;------将20H-26H中从PCF8563T中读出的7个字节参数的无关位屏蔽掉------
ADJUST:	
	PUSH	ACC
	MOV	A,20H			;处理秒单元
	ANL	A,#7FH
	MOV	20H,A		
	MOV	A,21H			;处理分单元		
	ANL	A,#7FH
	MOV	21H,A
	MOV	A,22H			;处理小时单元
	ANL	A,#3FH
	MOV	22H,A
	MOV	A,23H			;处理日期单元
	ANL	A,#3FH
	MOV	23H,A
	MOV	A,24H			;处理星期单元
	ANL	A,#07H
	MOV	24H,A
	MOV	A,25H			;处理月单元
	ANL	A,#1FH	
	MOV	25H,A
	POP		ACC
	RET
;------延时子程序------
DELAY:	
	PUSH	00H
	PUSH	01H
	MOV	R0,#00H
DELAY1:
	MOV	R1,#00H
	DJNZ	R1,$
	DJNZ	R0,DELAY1
	POP		01H
	POP		00H
	RET

;------整点报时(500Hz)------
BUZZ:	
	MOV	TMOD,#01H		;置T0为方式1
	MOV	TL0,#00H		;设置T0定时1ms
	MOV	TH0,#0FEH		
	MOV	R7,#00			;设置R7为循环计数器
	SETB	TR0				;启动T0
LOOP:	
	JNB		TF0,$		;判断1ms是否到达
  	CLR		TF0			;软件清零，为下次循环做准备
	MOV	TL0,#00H	;重赋1ms的初值
	MOV	TH0,#0FEH
	CPL		P1.4			;驱动蜂鸣器
	DJNZ	R7,LOOP
	CLR		TR0
	SETB	P1.4			;置高，使PNP截止
	RET

;------整点报时(1000Hz)------
BUZZ1:  
	MOV	TMOD,#01H		;置T0为方式1
	MOV	TL0,#00H		;设置T0定时0.5ms
	MOV	TH0,#0FFH	
	MOV	R7,#00			;设置R7为循环计数器
	MOV	R6,#5
	SETB	TR0			;启动T0
LOOP1:	
	JNB		TF0,$		;判断0.5ms是否到达
 	CLR		TF0			;软件清零，为下次循环做准备
	MOV	TL0,#00H	;重赋0.5ms的初值
	MOV	TH0,#0FFH
	CPL		P1.4			;驱动蜂鸣器
	DJNZ	R7,LOOP1
	DJNZ	R6,LOOP1
	CLR		TR0
	SETB	P1.4			;置高，使PNP截止
	RET        	

;------键盘修改时间中断服务子程序INT_7290------
INT_7290:
	PUSH	00H
	PUSH	02H
	PUSH	03H
	PUSH	04H
	PUSH	07H
	PUSH	ACC
	PUSH	PSW
	CLR	C						;清除标志位

NEXT:	
	MOV  	40H,#01110000B		;设置不闪烁
  	MOV	41H,#00000000B
	LCALL	FLASH
  	LCALL	RDKEY				;读取第一个按键值

;------设置时钟闪烁------
	CJNE	A,#0AH,BKEY		;判断是A键吗？不是返回，是则处理小时
AKEY:	
	MOV  	40H,#01110000B		;设置小时闪烁
  	MOV	41H,#11000000B
	LCALL	FLASH	
A1:	
	JB	P3.2,$			;以查询方式等待下一次按键		
	LCALL	RDKEY			;读取第二个按键值（小时数据的十位）
	CJNE	A,#02H,ABIG		;判断结果不等于2则跳转，小于2标志位Cy=1，大于等于2则为0
	LJMP	ATRUE			;等于2则正常处理数据
ABIG:	
	JC	ATRUE			;Cy=0则继续执行，Cy=1跳转
	LCALL	BUZZ			;按键值大于2发出警报
	LJMP	A1
ATRUE:	
	SWAP	A			;将键值数据处理成小时数据的十位
	ANL	14H,#00H		;将小时单元清零
	ORL	14H,A			;14H单元中的"十位"数生成
	LCALL	WR8563			;将修改后的参数送PCF8563T
	LCALL	DISPLAY
A2:
	JB	P3.2,$			;以查询方式等待下一次按键
	LCALL	RDKEY			;读取第三个按键值（小时数据的个位）
	CLR	C			;清除标志位
	MOV	R0,14H			;读取小时单元
	CJNE	R0,#20H,ABIG2		;判断十位是否为2？不等于则跳转，小于标志位Cy=1，等于则为0


	CJNE	A,#04H,ASMALL		;判断结果不等于4则跳转，小于4标志位Cy=1，大于等于4则为0
ASMALL:
	JC	ATRUE1			;Cy=1跳转，Cy=0即报错
	LCALL	BUZZ
	LJMP	A2	
ABIG2:
	CJNE	A,#09H,ASMALL2
ASMALL2:
	JC		ATRUE1
	LCALL	BUZZ
	LJMP	A2	
ATRUE1:	
	ANL	14H,#0F0H		;将键值数据处理成小时数据的个位
	ORL	14H,A
	LCALL	WR8563			;将修改后的参数送PCF8563T
	LCALL	DISPLAY
	JB	P3.2,$			;以查询方式等待下一次按键
	JMP	NEXT

;------设置分钟闪烁------

BKEY:	
	CJNE	A,#0BH,CKEY		;判断是B键吗？不是返回，是则处理分钟
	MOV  	40H,#01110000B		;设置分钟闪烁
	MOV	41H,#00011000B
	LCALL	FLASH	

B1:	
	JB	P3.2,$			;以查询方式等待下一次按键		
	LCALL	RDKEY			;读取第二个按键值（分钟数据的十位）
	CJNE	A,#05H,BBIG	;十位不等于5则跳转，小于5 Cy=1,大于等于5则为0
	
	LJMP	BTRUE

BBIG:	
	JC	BTRUE			;Cy=0则继续执行，Cy=1跳转
	LCALL	BUZZ
	LJMP	B1
BTRUE:	
	SWAP	A			;将键值数据处理成分钟数据的十位
	ANL	13H,#0FH
	ORL	13H,A			;13H单元中的"十位"数生成
	LCALL	WR8563			;将修改后的参数送PCF8563T
	LCALL	DISPLAY
B2:
	JB	P3.2,$			;以查询方式等待下一次按键
	LCALL	RDKEY			;读取第三个按键值（分钟数据的个位）
	CJNE	A,#10H,BBIG2		;判断按键值与10的关系
BBIG2:	
	JC		BTRUE1
	LCALL	BUZZ
	LJMP	B2
BTRUE1:	
	ANL	13H,#0F0H		;将键值数据处理成分钟数据的个位
	ORL	13H,A
	LCALL	WR8563			;将修改后的参数送PCF8563T
	LCALL	DISPLAY
	JB		P3.2,$			;以查询方式等待下一次按键
	JMP		NEXT
;------设置秒钟闪烁------
CKEY:	
	CJNE	A,#0CH,DOWN		;判断是C键吗？不是返回，是则处理秒
	MOV  	40H,#01110000B		;设置闪烁
	MOV	41H,#00000011B
	LCALL	FLASH	
C1:	
	JB		P3.2,$		;以查询方式等待下一次按键		
	LCALL	RDKEY			;读取第二个按键值（秒数据的十位）
	CJNE	A,#05H,CBIG		;十位不等于5则跳转，小于5标志位Cy=1，大于等于5则为0							
	LJMP	CTRUE
CBIG:	
	JC		CTRUE
	LCALL	BUZZ
	LJMP	C1
CTRUE:
	SWAP	A				;将键值数据处理成秒数据的十位
	ANL	12H,#0FH
	ORL	12H,A			;12H单元中的"十位"数生成
	LCALL	WR8563			;将修改后的参数送PCF8563T
	LCALL	DISPLAY
C2:
	JB	P3.2,$			;以查询方式等待下一次按键
	LCALL	RDKEY			;读取第三个按键值（秒数据的个位？）
	CJNE	A,#0AH,CBIG2		;秒参数个位大于等于10？
CBIG2:	
	JC		CTRUE1
	LCALL	BUZZ
	LJMP	C2
CTRUE1:	
	ANL	12H,#0F0H		;将键值数据处理成秒数据的个位
	ORL	12H,A
	LCALL	WR8563			;将修改后的参数送PCF8563T
	LCALL	DISPLAY
	JB		P3.2,$			;以查询方式等待下一次按键
	JMP		NEXT
DOWN:   
	CLR		IE0				;必须清标志
	POP		PSW
	POP		ACC
	POP		07H
	POP		04H
	POP		03H
	POP		02H
	POP		00H
	RETI	
;------读键值子程序（出口参数累加器A--获取到的键值）------
RDKEY:	
	MOV	R0,#1FH			;键值缓冲单元
	MOV	R7,#01H			;取一个数据（键值）
	MOV	R2,#01H			;指向内部数据键值寄存器地址
	MOV	R3,#WSLA_7290	;取器件地址（写）
	MOV	R4,#RSLA_7290	;取器件地址（读）
	LCALL	RDADD			;读取7290的01H单元中的键值
	MOV	A,1FH			;取键值送缓冲单元
	DEC	A				;S11、S12、S13分别对应A、B、C
	RET
;----------------------向日历芯片写入时间参数子程序---------------------
;------将RAM的10H-1DH中的时间参数（含控制字）写入芯片的00H-0DH单元------
WR8563:	
	MOV	R7,#0EH			;写入参数个数（时间和控制字）
	MOV	R0,#10H			;参数和控制命令缓冲区首地址
	MOV	R2,#00H			;从器件内部地址
	MOV	R3,#WSLA_8563	;准备向PCF8563T写入数据串
	LCALL	WRNBYT		;写入时间、控制命令到PCF8563T
	RET
;------闪烁------
FLASH:  
	MOV	R7,#02H
	MOV	R0,#40H
	MOV	R2,#07H
	MOV	R3,#WSLA_7290
	LCALL	WRNBYT
	LCALL	DELAY
	RET
;------回显------
DISPLAY:	
	MOV	R7,#07H	       	;读出数个数
	MOV	R0,#20H			;目标数据块首地址
	MOV	R2,#02H			;从器件内部从地址
	MOV	R3,#WSLA_8563	
	MOV	R4,#RSLA_8563	;准备读时间参数
	LCALL	RDADD			;调读数据子程序，读出数据		
	LCALL	ADJUST			;时间调整
	LCALL	CHAIFEN		;拆分子程序并查表
	MOV	R7,#08H
	MOV	R2,#10H
	MOV	R3,#WSLA_7290
	MOV	R0,#38H			;显示小时，分钟和秒
	LCALL	WRNBYT		;调ZLG7290B显示
	LCALL	DELAY
   	RET
;------ic相关子程序------
WRNBYT:	PUSH	PSW	;P254
	PUSH	ACC
WRADD:	MOV	A,R3	;取外围器件地址(包含R/W=0)
	LCALL	STA	;发送起始信号s
	LCALL	WRBYT	;发送外围地址
	LCALL	CACK	;检测外围器件的应答信号
	JB	F0,WRADD	;如果应答不正确就返回
	MOV	A,R2
	LCALL	WRBYT	;发送内部寄存器首地址
	LCALL	CACK	;检测外围器件的应答信号
	JB	F0,WRADD	;如果应答不正确就返回
WRDA:	MOV	A,@R0
	LCALL	WRBYT	;发送外围地址
	LCALL	CACK	;检测外围器件的应答信号
	JB	F0,WRADD	;如果应答不正确就返回
	INC	R0
	DJNZ	R7,WRDA
	LCALL	STOP
	POP	ACC
	POP	PSW
	RET
	


RDADD:	PUSH	PSW
	PUSH	ACC
RDADD1:	LCALL	STA
	MOV	A,R3	;取器件地址（写）
	LCALL	WRBYT	;发送外围地址
	LCALL	CACK	;检测外围器件的应答信号
	JB	F0,RDADD1	;如果应答不正确返回
	MOV	A,R2	;取内部地址
	LCALL	WRBYT	;发送外围地址
	LCALL	CACK	;检测外围器件的应答信号
	JB	F0,RDADD1	;如果应答不正确返回
	LCALL	STA
	MOV	A,R4	;取器件地址（读）
	LCALL	WRBYT	;发送外围地址
	LCALL	CACK	;检测外围器件的应答信号
	JB	F0,RDADD1	;如果应答不正确返回
RDN:	LCALL	RDBYT
	MOV	@R0,A
	DJNZ	R7,ACK
	LCALL	MNACK
	LCALL	STOP
	POP	ACC
	POP	PSW
	RET
ACK:	LCALL	MACK
	INC	R0
	SJMP	RDN
	







STA:	SETB	SDA
	SETB	SCL
	NOP
	NOP
	NOP
	NOP
	NOP
	CLR	SDA
	NOP
	NOP
	NOP
	NOP
	NOP
	CLR	SCL
	RET










STOP:	CLR	SDA
	SETB	SCL
	NOP
	NOP
	NOP
	NOP
	NOP
	SETB	SDA
	NOP
	NOP
	NOP
	NOP
	NOP
	SETB	SCL
	SETB	SDA
	RET








MACK:	CLR	SDA
	SETB	SCL
	NOP
	NOP
	NOP
	NOP
	NOP
	CLR	SCL
	SETB	SDA
	RET









MNACK:	SETB	SDA
	SETB	SCL
	NOP
	NOP
	NOP
	NOP
	NOP
	CLR	SCL
	CLR	SDA
	RET








CACK:	SETB	SDA
	SETB	SCL
	CLR	F0
	MOV	C,SDA
	JNC	CEND
	SETB	F0
CEND:	CLR	SCL
	RET






WRBYT:	PUSH	06H
MOV	R6,#08H
WLP:	RLC	A
	MOV	SDA,C
	SETB	SCL
	NOP
	NOP
	NOP
	NOP
	NOP
	JNB	SCL,$
	CLR	SCL
	DJNZ	R6,WLP
	POP	06H
	RET









RDBYT:	PUSH	06H
	MOV	R6,#08H
RLP:	SETB	SDA
	SETB	SCL
	JNB	SCL,$
	MOV	C,SDA
	MOV	A,R2
	RLC	A
	MOV	R2,A
	CLR	SCL
	DJNZ	R6,RLP
	POP	06H
	RET
	

END